// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    NeuigkeitEntityListResponseDTO,
} from '../models';

export interface DeleteAllElementsRequest {
    id: string;
}

export interface GetNeuigkeitenListRequest {
    pageNumber: number;
}

export interface SetElementMarkAsReadRequest {
    id: string;
    setUngelesen: boolean;
}

/**
 * no description
 */
export class NeuigkeitControllerApi extends BaseAPI {

    /**
     * Löscht eine Neuigkeit im Dashboard
     * Löscht eine Neuigkeit
     */
    deleteAllElements({ id }: DeleteAllElementsRequest): Observable<void>
    deleteAllElements({ id }: DeleteAllElementsRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteAllElements({ id }: DeleteAllElementsRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'deleteAllElements');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/neuigkeiten/{id}'.replace('{id}', encodeURI(id)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Löscht alle Neuigkeiten im Dashboard
     * Löscht alle Neuigkeiten
     */
    deleteAllElements1(): Observable<void>
    deleteAllElements1(opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteAllElements1(opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/neuigkeiten/delete-all',
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt eine Seite der Neuigkeiten für das Dashboard.
     * Lädt eine paginierte Liste von Neuigkeiten
     */
    getNeuigkeitenList({ pageNumber }: GetNeuigkeitenListRequest): Observable<NeuigkeitEntityListResponseDTO>
    getNeuigkeitenList({ pageNumber }: GetNeuigkeitenListRequest, opts?: OperationOpts): Observable<AjaxResponse<NeuigkeitEntityListResponseDTO>>
    getNeuigkeitenList({ pageNumber }: GetNeuigkeitenListRequest, opts?: OperationOpts): Observable<NeuigkeitEntityListResponseDTO | AjaxResponse<NeuigkeitEntityListResponseDTO>> {
        throwIfNullOrUndefined(pageNumber, 'pageNumber', 'getNeuigkeitenList');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<NeuigkeitEntityListResponseDTO>({
            url: '/neuigkeiten/overview/{pageNumber}'.replace('{pageNumber}', encodeURI(pageNumber)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Markiert einen Eintrag als gelesen
     * Markiert als gelesen
     */
    setElementMarkAsRead({ id, setUngelesen }: SetElementMarkAsReadRequest): Observable<void>
    setElementMarkAsRead({ id, setUngelesen }: SetElementMarkAsReadRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    setElementMarkAsRead({ id, setUngelesen }: SetElementMarkAsReadRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'setElementMarkAsRead');
        throwIfNullOrUndefined(setUngelesen, 'setUngelesen', 'setElementMarkAsRead');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/neuigkeiten/{id}/{setUngelesen}'.replace('{id}', encodeURI(id)).replace('{setUngelesen}', encodeURI(setUngelesen)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Markiert alle Einträge als gelesen
     * Markiert als gelesen
     */
    setElementeMarkAsRead(): Observable<void>
    setElementeMarkAsRead(opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    setElementeMarkAsRead(opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/neuigkeiten/mark-all-as-read',
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

}
